=== modified file 'database/replication/generate_migration.py'
--- database/replication/generate_migration.py	2011-10-11 06:25:04 +0000
+++ database/replication/generate_migration.py	2011-10-13 03:52:48 +0000
@@ -147,7 +147,9 @@
     message(outf, "Creating %s origin %d" % (set_name, origin_node.node_id))
     print >> outf, "create set (id=%d, origin=@%s_origin, comment='%s');" % (
         set_id, set_name, set_name)
-    cur = con.cursor()
+    # Need to connect to a node currently replicating the desired set.
+    origin_con = origin_node.connect()
+    cur = origin_con.cursor()
     cur.execute("""
         SELECT tab_id, tab_nspname, tab_relname, tab_comment
         FROM _sl.sl_table WHERE tab_set=%s

=== modified file 'database/replication/helpers.py'
--- database/replication/helpers.py	2011-10-10 14:58:41 +0000
+++ database/replication/helpers.py	2011-10-13 03:52:48 +0000
@@ -10,8 +10,14 @@
 from tempfile import NamedTemporaryFile
 from textwrap import dedent
 
+import psycopg2
+
 from canonical.config import config
-from canonical.database.sqlbase import connect, sqlvalues
+from canonical.database.sqlbase import (
+    connect,
+    ISOLATION_LEVEL_DEFAULT,
+    sqlvalues
+    )
 from canonical.database.postgresql import (
     fqn, all_tables_in_schema, all_sequences_in_schema, ConnectionString
     )
@@ -224,6 +230,11 @@
         self.connection_string = connection_string
         self.is_master = is_master
 
+    def connect(self, isolation=ISOLATION_LEVEL_DEFAULT):
+        con = psycopg2.connect(self.connection_string)
+        con.set_isolation_level(isolation)
+        return con
+
 
 def _get_nodes(con, query):
     """Return a list of Nodes."""

